<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripItemResult_V4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripItemResult_V4 extends AbstractStructArrayBase
{
    /**
     * The TripItemResult_V4
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripItemResult_V4[]
     */
    public $TripItemResult_V4;
    /**
     * Constructor method for ArrayOfTripItemResult_V4
     * @uses ArrayOfTripItemResult_V4::setTripItemResult_V4()
     * @param \StructType\TripItemResult_V4[] $tripItemResult_V4
     */
    public function __construct(array $tripItemResult_V4 = array())
    {
        $this
            ->setTripItemResult_V4($tripItemResult_V4);
    }
    /**
     * Get TripItemResult_V4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripItemResult_V4[]|null
     */
    public function getTripItemResult_V4()
    {
        return isset($this->TripItemResult_V4) ? $this->TripItemResult_V4 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTripItemResult_V4 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTripItemResult_V4 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTripItemResult_V4ForArrayConstraintsFromSetTripItemResult_V4(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTripItemResult_V4TripItemResult_V4Item) {
            // validation for constraint: itemType
            if (!$arrayOfTripItemResult_V4TripItemResult_V4Item instanceof \StructType\TripItemResult_V4) {
                $invalidValues[] = is_object($arrayOfTripItemResult_V4TripItemResult_V4Item) ? get_class($arrayOfTripItemResult_V4TripItemResult_V4Item) : sprintf('%s(%s)', gettype($arrayOfTripItemResult_V4TripItemResult_V4Item), var_export($arrayOfTripItemResult_V4TripItemResult_V4Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TripItemResult_V4 property can only contain items of type \StructType\TripItemResult_V4, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TripItemResult_V4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripItemResult_V4[] $tripItemResult_V4
     * @return \ArrayType\ArrayOfTripItemResult_V4
     */
    public function setTripItemResult_V4(array $tripItemResult_V4 = array())
    {
        // validation for constraint: array
        if ('' !== ($tripItemResult_V4ArrayErrorMessage = self::validateTripItemResult_V4ForArrayConstraintsFromSetTripItemResult_V4($tripItemResult_V4))) {
            throw new \InvalidArgumentException($tripItemResult_V4ArrayErrorMessage, __LINE__);
        }
        if (is_null($tripItemResult_V4) || (is_array($tripItemResult_V4) && empty($tripItemResult_V4))) {
            unset($this->TripItemResult_V4);
        } else {
            $this->TripItemResult_V4 = $tripItemResult_V4;
        }
        return $this;
    }
    /**
     * Add item to TripItemResult_V4 value
     * @throws \InvalidArgumentException
     * @param \StructType\TripItemResult_V4 $item
     * @return \ArrayType\ArrayOfTripItemResult_V4
     */
    public function addToTripItemResult_V4(\StructType\TripItemResult_V4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripItemResult_V4) {
            throw new \InvalidArgumentException(sprintf('The TripItemResult_V4 property can only contain items of type \StructType\TripItemResult_V4, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TripItemResult_V4[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripItemResult_V4|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripItemResult_V4|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripItemResult_V4|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripItemResult_V4|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripItemResult_V4|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripItemResult_V4
     */
    public function getAttributeName()
    {
        return 'TripItemResult_V4';
    }
}
